package com.unis.policy.info.config;

import com.github.xiaoymin.knife4j.spring.extension.OpenApiExtensionResolver;
import com.unis.common.pojo.CommonResult;
import io.swagger.annotations.ApiOperation;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.web.bind.annotation.RequestMethod;
import springfox.documentation.builders.ApiInfoBuilder;
import springfox.documentation.builders.PathSelectors;
import springfox.documentation.builders.RequestHandlerSelectors;
import springfox.documentation.service.Contact;
import springfox.documentation.spi.DocumentationType;
import springfox.documentation.spring.web.plugins.Docket;

import javax.annotation.Resource;

/**
 * 业务相关配置
 *
 * @author xuyuxiang
 * @date 2022/7/7 16:18
 **/
@Configuration
public class PolicyInfoConfigure {

    @Resource
    private OpenApiExtensionResolver openApiExtensionResolver;

    /**
     * API文档分组配置
     *
     * @author TS
     * @date 2024/4/3 16:18
     **/
    @Bean(value = "policyInfoDocApi")
    public Docket policyInfoDocApi() {
        return new Docket(DocumentationType.SWAGGER_2)
                .apiInfo(new ApiInfoBuilder()
                        .title("行政业务")
                        .description("行政业务")
                        .termsOfServiceUrl("https://www.xiaonuo.vip")
                        .contact(new Contact("UNIS_TEAM","https://www.xiaonuo.vip", "xuyuxiang29@foxmail.com"))
                        .version("1.0.0")
                        .build())
                .globalResponseMessage(RequestMethod.GET, CommonResult.responseList())
                .globalResponseMessage(RequestMethod.POST, CommonResult.responseList())
                .groupName("行政业务")
                .select()
                .apis(RequestHandlerSelectors.withMethodAnnotation(ApiOperation.class))
                .apis(RequestHandlerSelectors.basePackage("com.unis.policy.info"))
                .paths(PathSelectors.any())
                .build().extensions(openApiExtensionResolver.buildExtensions("行政业务"));
    }
}
